/* tslint:disable */
// generated by typescript-json-validator
import { inspect } from "util";
import Ajv, { ErrorObject } from "ajv";
import StartMessage from "./startMessage";
import schema from "ajv/lib/refs/json-schema-draft-06.json";
export const ajv = new Ajv({
  allErrors: true,
  coerceTypes: false,
  format: "fast",
  nullable: true,
  unicode: true,
  uniqueItems: true,
  useDefaults: true,
});

ajv.addMetaSchema(schema);

export const StartMessageSchema = {
  $schema: "http://json-schema.org/draft-07/schema#",
  additionalProperties: false,
  defaultProperties: [],
  properties: {
    board: {
      items: {
        additionalItems: {
          anyOf: [
            {
              enum: ["a", "b", "c", "d", "e", "f", "g", "h"],
              type: "string",
            },
            {
              enum: [1, 2, 3, 4, 5, 6, 7, 8],
              type: "number",
            },
            {
              enum: ["bishop", "king", "knight", "pawn", "queen", "rook"],
              type: "string",
            },
            {
              enum: ["black", "white"],
              type: "string",
            },
          ],
        },
        items: [
          {
            enum: ["a", "b", "c", "d", "e", "f", "g", "h"],
            type: "string",
          },
          {
            enum: [1, 2, 3, 4, 5, 6, 7, 8],
            type: "number",
          },
          {
            enum: ["bishop", "king", "knight", "pawn", "queen", "rook"],
            type: "string",
          },
          {
            enum: ["black", "white"],
            type: "string",
          },
        ],
        minItems: 4,
        type: "array",
      },
      type: "array",
    },
    gameId: {
      type: "string",
    },
  },
  required: ["board", "gameId"],
  type: "object",
};
export type ValidateFunction<T> = ((data: unknown) => data is T) &
  Pick<Ajv.ValidateFunction, "errors">;
export const isStartMessage = ajv.compile(
  StartMessageSchema
) as ValidateFunction<StartMessage>;
export default function validate(value: unknown): StartMessage {
  if (isStartMessage(value)) {
    return value;
  } else {
    if (Array.isArray(isStartMessage.errors)) {
      throw new Error(
        ajv.errorsText(
          isStartMessage.errors.filter((e: ErrorObject) => e.keyword !== "if"),
          { dataVar: "StartMessage" }
        ) +
          "\n\n" +
          inspect(value)
      );
    }

    throw new Error("Unknown error");
  }
}
